Index: code/trunk/TODO
===================================================================
--- code/trunk/TODO	(revision 1906)
+++ code/trunk/TODO	(revision 1907)
@@ -1,2 +1,14 @@
-- should we use enet_peer_ping to test if a client is still alive ?
-- enet_host_broadcast ? (to all peers)
+todo: 
+	!!! check that enet does not cause a packet traffic jam when a reliable packet gets missed !!!
+	[implemented] new gamestate concept
+
+	!!! ensure that objects get synched, when newly created, even if not their tick
+
+	setvariable mode
+	objectmode
+	priorities (put into gamestatehandler)
+		manage delete object handling (only send deletes of acked objects)
+	static (sync once) & triggerSync
+
+REMARKS:
+	try to allocate sort the bytestream before copy (putt all 0's in one place)
Index: code/trunk/bin/ogre.cfg-init
===================================================================
--- code/trunk/bin/ogre.cfg-init	(revision 1906)
+++ code/trunk/bin/ogre.cfg-init	(revision 1907)
@@ -4,4 +4,4 @@
 FSAA=0
 Full Screen=No
-RTT Preferred Mode=FBO
-Video Mode=1024 x 768
+RTT Preferred Mode=PBuffer
+Video Mode=640 x 480
Index: code/trunk/src/network/CMakeLists.txt
===================================================================
--- code/trunk/src/network/CMakeLists.txt	(revision 1906)
+++ code/trunk/src/network/CMakeLists.txt	(revision 1907)
@@ -17,4 +17,5 @@
   packet/Gamestate.cc
   packet/Welcome.cc
+  packet/DeleteObjects.cc
 )
 
Index: code/trunk/src/network/Client.cc
===================================================================
--- code/trunk/src/network/Client.cc	(revision 1906)
+++ code/trunk/src/network/Client.cc	(revision 1907)
@@ -43,5 +43,4 @@
 #include "Synchronisable.h"
 #include "core/CoreIncludes.h"
-#include "core/ConsoleCommand.h"
 #include "packet/Packet.h"
 // #include "packet/Acknowledgement.h"
@@ -61,5 +60,4 @@
     isSynched_=false;
     gameStateFailure_=false;
-    isServer_ = false;
   }
 
@@ -73,5 +71,4 @@
     isSynched_=false;
     gameStateFailure_=false;
-    isServer_ = false;
   }
 
@@ -85,5 +82,4 @@
     isSynched_=false;
     gameStateFailure_=false;
-    isServer_ = false;
   }
 
@@ -118,32 +114,24 @@
   }
 
-  bool Client::processChat(packet::Chat *message, unsigned int clientID){
-    return message->process();
+  bool Client::processChat(std::string message, unsigned int playerID){
+    COUT(1) << "Player " << playerID << ": " << message << std::endl;
+    return true;
   }
-
-  /*bool Client::sendChat(packet::Chat *chat){
-    chat->process();
-    packet::Packet *p = new packet::Packet(chat);
-    return p->send();
-  }*/
+  
+  /**
+   * This function implements the method of sending a chat message to the server
+   * @param message message to be sent 
+   * @return result(true/false)
+   */
+  bool Client::chat(std::string message){
+    packet::Chat *m = new packet::Chat(message, Host::getPlayerID());
+    return m->send();
+  }
 
 
   /**
-  * submits a chat message to the server
-  * @param message message to send
-  * @return true/false
-  */
-  bool Client::sendChat( std::string message ){
-    // generate packet and add it to queue
-    if(!isConnected)
-      return false;
-    packet::Chat chat(message, 0);
-    return chat.send();
-    // send packets
-  }
-
-  /**
-  * Performs a GameState update
-  */
+   * Processes incoming packets, sends a gamestate to the server and does the cleanup
+   * @param time 
+   */
   void Client::tick(float time){
 //     COUT(3) << ".";
@@ -164,5 +152,6 @@
       COUT(5) << "tick packet size " << event->packet->dataLength << std::endl;
       packet::Packet *packet = packet::Packet::createPacket(event->packet, event->peer);
-      assert(packet->process());
+      bool b = packet->process();
+      assert(b);
     }
     if(gamestate.processGamestates())
@@ -170,6 +159,5 @@
       if(!isSynched_)
         isSynched_=true;
-    }else
-      COUT(3) << "gamestate has not been processed sucessfully" << std::endl;
+    }
     gamestate.cleanup();
     return;
Index: code/trunk/src/network/Client.h
===================================================================
--- code/trunk/src/network/Client.h	(revision 1906)
+++ code/trunk/src/network/Client.h	(revision 1907)
@@ -73,11 +73,10 @@
     bool closeConnection();
     bool queuePacket(ENetPacket *packet, int clientID);
-    bool processChat(packet::Chat *message, unsigned int clientID);
+    bool processChat(std::string message, unsigned int playerID);
+    virtual bool chat(std::string message);
     //bool sendChat(packet::Chat *chat);
     
 //    static void Chat( std::string message );
     
-    unsigned int shipID(){return shipID_;}
-    int playerID(){return clientID_;}
     //static void setShipID( unsigned int shipID){ dynamic_cast<Client *>(instance_)->shipID_=shipID; }
     static void setClientID( unsigned int clientID){ dynamic_cast<Client *>(instance_)->clientID_=clientID; }
@@ -86,4 +85,5 @@
 
   private:
+    virtual bool isServer_(){return false;}
     
     ClientConnection client_connection;
@@ -91,11 +91,5 @@
     bool isConnected;
     bool isSynched_;
-
-    bool sendChat( std::string message );
     
-    // implement data processing functions of PacketDecoder
-//     void processChat( chat *data, int clientId );
-    int clientID_;     // this is the id the server gave to us
-    int shipID_;
     bool gameStateFailure_;
   };
Index: code/trunk/src/network/ClientConnection.cc
===================================================================
--- code/trunk/src/network/ClientConnection.cc	(revision 1906)
+++ code/trunk/src/network/ClientConnection.cc	(revision 1907)
@@ -77,19 +77,8 @@
   }
 
-
-  /*ENetPacket *ClientConnection::getPacket(ENetAddress &address) {
-    if(!buffer.isEmpty()) {
-      //std::cout << "###BUFFER IS NOT EMPTY###" << std::endl;
-      return buffer.pop(address);
-    }
-    else{
-      return NULL;
-    }
-  }
-
-  ENetPacket *ClientConnection::getPacket() {
-    ENetAddress address; //sems that address is not needed
-    return getPacket(address);
-  }*/
+  ClientConnection::~ClientConnection(){
+    if(established)
+      closeConnection();
+  }
 
   ENetEvent *ClientConnection::getEvent(){
Index: code/trunk/src/network/ClientConnection.h
===================================================================
--- code/trunk/src/network/ClientConnection.h	(revision 1906)
+++ code/trunk/src/network/ClientConnection.h	(revision 1907)
@@ -64,6 +64,5 @@
     ClientConnection(int port, std::string address);
     ClientConnection(int port, const char* address);
-    //ENetPacket *getPacket(ENetAddress &address); // thread1
-    //ENetPacket *getPacket(); // thread1
+    ~ClientConnection();
     ENetEvent *getEvent();
     // check wheter the packet queue is empty
Index: code/trunk/src/network/ConnectionManager.cc
===================================================================
--- code/trunk/src/network/ConnectionManager.cc	(revision 1906)
+++ code/trunk/src/network/ConnectionManager.cc	(revision 1907)
@@ -81,12 +81,4 @@
   boost::recursive_mutex ConnectionManager::enet_mutex;
 
-//   ConnectionManager::ConnectionManager(ClientInformation *head) : receiverThread_(0) {
-//     assert(instance_==0);
-//     instance_=this;
-//     quit=false;
-//     bindAddress.host = ENET_HOST_ANY;
-//     bindAddress.port = NETWORK_PORT;
-//   }
-
   ConnectionManager::ConnectionManager(int port){
     assert(instance_==0);
@@ -114,28 +106,9 @@
 
   ConnectionManager::~ConnectionManager(){
-    instance_=0;
     if(!quit)
       quitListener();
-  }
-
-  /*ENetPacket *ConnectionManager::getPacket(ENetAddress &address) {
-    if(!buffer.isEmpty())
-      return buffer.pop(address);
-    else
-      return NULL;
-  }*/
-/**
-This function only pops the first element in PacketBuffer (first in first out)
-used by processQueue in Server.cc
-*/
-  /*ENetPacket *ConnectionManager::getPacket(int &clientID) {
-    ENetAddress address;
-    ENetPacket *packet=getPacket(address);
-    ClientInformation *temp =head_->findClient(&address);
-    if(!temp)
-      return NULL;
-    clientID=temp->getID();
-    return packet;
-  }*/
+    instance_=0;
+  }
+
 
   ENetEvent *ConnectionManager::getEvent(){
@@ -164,14 +137,4 @@
   }
 
-//   bool ConnectionManager::addPacket(Packet::Packet *packet){
-//     ClientInformation *temp = instance_->head_->findClient(packet->getClientID());
-//     if(!temp){
-//       COUT(3) << "C.Man: addPacket findClient failed" << std::endl;
-//       return false;
-//     }
-//     ENetPacket *packet = new ENetPacket;
-//     //  TODO: finish implementation
-//   }
-//
 
   bool ConnectionManager::addPacket(ENetPacket *packet, ENetPeer *peer) {
@@ -373,5 +336,5 @@
     orxonox::ObjectList<orxonox::SpaceShip>::iterator it;
     for(it = orxonox::ObjectList<orxonox::SpaceShip>::begin(); it; ++it){
-      if(it->objectID!=id)
+      if(it->getObjectID()!=id)
         continue;
       delete *it;
Index: code/trunk/src/network/GamestateClient.cc
===================================================================
--- code/trunk/src/network/GamestateClient.cc	(revision 1906)
+++ code/trunk/src/network/GamestateClient.cc	(revision 1907)
@@ -156,5 +156,5 @@
     if(myShip_){
       //      unsigned char *data = new unsigned char[myShip_->getSize()];
-      int size=myShip_->getSize2(0, 0x1);
+      int size=myShip_->getSize(0, 0x1);
       if(size==0)
         return false;
@@ -182,5 +182,8 @@
   packet::Gamestate *GamestateClient::processGamestate(packet::Gamestate *gs){
     if(gs->isCompressed())
-      assert(gs->decompressData());
+    {
+      bool b = gs->decompressData();
+      assert(b);
+    }
     if(gs->isDiffed()){
       packet::Gamestate *base = gamestateMap_[gs->getBaseID()];
@@ -189,5 +192,5 @@
         return 0;
       }
-//      assert(base); //TODO: fix this
+//       assert(base); //TODO: fix this
       packet::Gamestate *undiffed = gs->undiff(base);
       delete gs;
Index: code/trunk/src/network/GamestateManager.cc
===================================================================
--- code/trunk/src/network/GamestateManager.cc	(revision 1906)
+++ code/trunk/src/network/GamestateManager.cc	(revision 1907)
@@ -61,5 +61,5 @@
 
   bool GamestateManager::update(){
-    cleanup();
+//     cleanup();
     return getSnapshot();
   }
@@ -92,7 +92,7 @@
     reference = new packet::Gamestate();
     reference->collectData(++id_);
-    COUT(4) << "inserting gamestate: " << reference << std::endl;
-    gamestateMap.insert(std::pair<int, packet::Gamestate*>(id_, reference));
-    gamestateUsed[id_]=0;
+    //COUT(4) << "inserting gamestate: " << reference << std::endl;
+    //gamestateMap_.insert(std::pair<int, packet::Gamestate*>(id_, reference));
+//     gamestateUsed[id_]=0;
     return true;
   }
@@ -104,5 +104,5 @@
    * 
    */
-  void GamestateManager::cleanup(){
+/*  void GamestateManager::cleanup(){
     std::map<int,int>::iterator it = gamestateUsed.begin();
     while(it!=gamestateUsed.end()){
@@ -124,5 +124,5 @@
       it++;
     }
-  }
+  }*/
 
   packet::Gamestate *GamestateManager::popGameState(int clientID) {
@@ -131,20 +131,29 @@
     packet::Gamestate *gs;
     int gID = ClientInformation::findClient(clientID)->getGamestateID();
-    //COUT(4) << "G.St.Man: popgamestate: sending gstate_id: " << id_ << " diffed from: " << gID << std::endl;
+    gs = reference->doSelection(clientID);
+//     gs = new packet::Gamestate(*reference);
+//     gs = new packet::Gamestate(*reference);
+    // save the (undiffed) gamestate in the clients gamestate map
+    gamestateMap_[clientID].insert(std::pair<int, packet::Gamestate*>(gs->getID(), gs));
     //chose wheather the next gamestate is the first or not
+    packet::Gamestate *client=NULL;
     if(gID != GAMESTATEID_INITIAL){
-      packet::Gamestate *client=NULL;
-      std::map<int, packet::Gamestate*>::iterator it = gamestateMap.find(gID);
-      if(it!=gamestateMap.end())
-        client = it->second;
-      if(client)
-        gs = reference->diff(client);
-      else
-        gs = new packet::Gamestate(*reference);
-    } else {
-      COUT(4) << "we got a GAMESTATEID_INITIAL for clientID: " << clientID << std::endl;
-      gs = new packet::Gamestate(*reference);
-    }
-    assert(gs->compressData());
+      std::map<unsigned int, std::map<int, packet::Gamestate*> >::iterator clientMap = gamestateMap_.find(clientID);
+      if(clientMap!=gamestateMap_.end()){
+        std::map<int, packet::Gamestate*>::iterator it = clientMap->second.find(gID);
+        if(it!=clientMap->second.end())
+          client = it->second;
+      }
+    }
+    if(client){
+//       COUT(3) << "diffing" << std::endl;
+      gs = gs->diff(client);
+    }
+    else{
+//       COUT(3) << "not diffing" << std::endl;
+      gs = new packet::Gamestate(*gs);
+    }
+    bool b = gs->compressData();
+    assert(b);
     return gs;
   }
@@ -153,47 +162,41 @@
   bool GamestateManager::ack(int gamestateID, int clientID) {
     ClientInformation *temp = ClientInformation::findClient(clientID);
-    if(temp==0)
-      return false;
+    assert(temp);
     int curid = temp->getGamestateID();
     
     if(gamestateID == 0){
       temp->setGamestateID(GAMESTATEID_INITIAL);
-      if(curid!=GAMESTATEID_INITIAL){
-        assert(gamestateUsed.find(curid)!=gamestateUsed.end());
-        --(gamestateUsed.find(curid)->second);
-      }
       return true;
     }
-    //if(curid > gamestateID)
+    
     assert(curid<gamestateID);
-      // the network packets got messed up 
-      //return true;
     COUT(4) << "acking gamestate " << gamestateID << " for clientid: " << clientID << " curid: " << curid << std::endl;
-    // decrease usage of gamestate and save it
-//     deleteUnusedGameState(curid);
-    //increase gamestateused
-    std::map<int, int>::iterator it = gamestateUsed.find(curid);
-    if(curid!=GAMESTATEID_INITIAL){
-      if(it!=gamestateUsed.end())
-        --(it->second);
-    }
-    it = gamestateUsed.find(gamestateID);
-    if(it!=gamestateUsed.end()){
-      ++(it->second);
-      temp->setGamestateID(gamestateID);
-    }
+    std::map<int, packet::Gamestate*>::iterator it, tempit;
+    for(it = gamestateMap_[clientID].begin(); it!=gamestateMap_[clientID].end() && it->first<gamestateID; it++){
+      delete it->second;
+      tempit=it++;
+      gamestateMap_[clientID].erase(tempit);
+    }
+    temp->setGamestateID(gamestateID);
     return true;
   }
 
   void GamestateManager::removeClient(ClientInformation* client){
-    if(!client)
-      return;
-    if(client->getGamestateID()>=0)
-      gamestateUsed[client->getGamestateID()]--;
+    assert(client);
+    std::map<unsigned int, std::map<int, packet::Gamestate*> >::iterator clientMap = gamestateMap_.find(client->getID());
+    // first delete all remained gamestates
+    std::map<int, packet::Gamestate*>::iterator it;
+    for(it=clientMap->second.begin(); it!=clientMap->second.end(); it++)
+      delete it->second;
+    // now delete the clients gamestatemap
+    gamestateMap_.erase(clientMap);
   }
   
   bool GamestateManager::processGamestate(packet::Gamestate *gs){
     if(gs->isCompressed())
-       assert(gs->decompressData());
+    {
+       bool b = gs->decompressData();
+       assert(b);
+    }
     assert(!gs->isDiffed());
     return gs->spreadData();
Index: code/trunk/src/network/GamestateManager.h
===================================================================
--- code/trunk/src/network/GamestateManager.h	(revision 1906)
+++ code/trunk/src/network/GamestateManager.h	(revision 1907)
@@ -81,9 +81,10 @@
     void removeClient(ClientInformation *client);
     private:
-    void cleanup(); // "garbage handler"
+//     void cleanup(); // "garbage handler"
     bool processGamestate(packet::Gamestate *gs);
 
-    std::map<int, packet::Gamestate*> gamestateMap; //map gsID to gamestate*
-    std::map<int, int> gamestateUsed; // save the number of clients, that use the specific gamestate
+    std::map<unsigned int, std::map<int, packet::Gamestate*> > gamestateMap_;
+    //std::map<int, packet::Gamestate*> gamestateMap; //map gsID to gamestate*
+    //std::map<int, int> gamestateUsed; // save the number of clients, that use the specific gamestate
     std::map<int, packet::Gamestate*> gamestateQueue;
     packet::Gamestate *reference;
Index: code/trunk/src/network/Host.cc
===================================================================
--- code/trunk/src/network/Host.cc	(revision 1906)
+++ code/trunk/src/network/Host.cc	(revision 1907)
@@ -30,12 +30,19 @@
 
 #include "Host.h"
+#include "core/ConsoleCommand.h"
 #include "packet/Packet.h"
 
 namespace network {
 
+SetConsoleCommandShortcut(Host, Chat);
+
 Host *Host::instance_=0;
   
+/**
+ * @brief Constructor: assures that only one reference will be created and sets the pointer
+ */
 Host::Host()
 {
+  clientID_=0;
   assert(instance_==0);
   instance_=this;
@@ -43,4 +50,7 @@
 
 
+/**
+ * @brief Destructor: resets the instance pointer to 0
+ */
 Host::~Host()
 {
@@ -48,4 +58,10 @@
 }
 
+/**
+ * This function is used to add an enetpacket to be sent to another peer
+ * @param packet Packet to be added
+ * @param clientID ID of the client the packet should be sent to
+ * @return success?
+ */
 bool Host::addPacket(ENetPacket *packet, int clientID){
   if(instance_)
@@ -70,15 +86,23 @@
 // }
 
-int Host::getPlayerID(){ 
+/**
+ * This function returns the ID of the player
+ * @return playerID
+ */
+unsigned int Host::getPlayerID(){ 
   if(!instance_)
     return 0;
-  return instance_->playerID();
+  return instance_->clientID_;
 }
 
-// unsigned int Host::getShipID(){ 
-//   if(!instance_)
-//     assert(0);
-//   return instance_->shipID();
-// }
+bool Host::Chat(std::string message){
+  if(!instance_)
+    return false;
+  return instance_->chat(message);
+}
+
+bool Host::incomingChat(std::string message, unsigned int playerID){
+  return instance_->processChat(message, playerID);
+}
 
 }//namespace network
Index: code/trunk/src/network/Host.h
===================================================================
--- code/trunk/src/network/Host.h	(revision 1906)
+++ code/trunk/src/network/Host.h	(revision 1907)
@@ -37,5 +37,10 @@
 
 /**
-	@author Oliver Scheuss
+*       @brief Base class of Server and Client
+*       This is the Base class of the Server and Client classes
+*       - Makes server and client a singleton
+*       - defines static functions available on both server and client
+*       - is the interface to be used when communicating with the network
+*	@author Oliver Scheuss
 */
 class Host{
@@ -45,6 +50,7 @@
     //virtual bool sendChat(packet::Chat *chat)=0;
     virtual bool queuePacket(ENetPacket *packet, int clientID)=0;
-    virtual unsigned int shipID()=0;
-    virtual int playerID()=0;
+    virtual bool chat(std::string message)=0;
+    virtual bool processChat(std::string message, unsigned int playerID)=0;
+    virtual bool isServer_()=0;
 
 
@@ -54,5 +60,6 @@
     virtual ~Host();
     static Host *instance_;
-    bool isServer_;	
+    unsigned int clientID_;
+    unsigned int shipID_;
 
   public:
@@ -61,12 +68,12 @@
     //static bool chat(std::string& message);
 //     static bool receiveChat(packet::Chat *message, unsigned int clientID);
-    static int getPlayerID();
+    static unsigned int getPlayerID();
     static unsigned int getShipID(){return instance_->shipID_;}
     static void setClientID(unsigned int id){ instance_->clientID_ = id; }
     static void setShipID(unsigned int id){ instance_->shipID_ = id; }
-    static bool isServer(){ return instance_->isServer_; }		
+    static bool isServer(){ return instance_->isServer_(); }		
+    static bool Chat(std::string message);
+    static bool incomingChat(std::string message, unsigned int playerID);
   private:
-    unsigned int clientID_;
-    unsigned int shipID_;
 };
 
Index: code/trunk/src/network/Server.cc
===================================================================
--- code/trunk/src/network/Server.cc	(revision 1906)
+++ code/trunk/src/network/Server.cc	(revision 1907)
@@ -56,4 +56,5 @@
 #include "packet/Packet.h"
 #include "packet/Welcome.h"
+#include "packet/DeleteObjects.h"
 #include <util/Convert.h>
 
@@ -71,5 +72,4 @@
     connection = new ConnectionManager();
     gamestates_ = new GamestateManager();
-    isServer_ = true;
   }
 
@@ -78,5 +78,4 @@
     connection = new ConnectionManager(port);
     gamestates_ = new GamestateManager();
-    isServer_ = true;
   }
 
@@ -90,5 +89,4 @@
     connection = new ConnectionManager(port, bindAddress);
     gamestates_ = new GamestateManager();
-    isServer_ = true;
   }
 
@@ -102,5 +100,14 @@
     connection = new ConnectionManager(port, bindAddress);
     gamestates_ = new GamestateManager();
-    isServer_ = true;
+  }
+  
+  /**
+  * @brief Destructor
+  */
+  Server::~Server(){
+    if(connection)
+      delete connection;
+    if(gamestates_)
+      delete gamestates_;
   }
 
@@ -121,45 +128,18 @@
   }
 
-  bool Server::processChat(packet::Chat *message, unsigned int clientID){
+  bool Server::processChat(std::string message, unsigned int playerID){
     ClientInformation *temp = ClientInformation::getBegin();
+    packet::Chat *chat;
     while(temp){
-      message->setClientID(temp->getID());
-      if(!message->send())
-        COUT(3) << "could not send Chat message to client ID: " << temp->getID() << std::endl;
-      temp = temp->next();
-    }
-    return message->process();
-  }
-
-  /**
-  * This function sends out a message to all clients
-  * @param msg message
-  * @return true/false
-  */
-  bool Server::sendChat(packet::Chat *chat) {
-    //TODO: change this (no informations about who wrote a message)
-    assert(0);
-    ClientInformation *temp = ClientInformation::getBegin();
-    while(temp){
+      chat = new packet::Chat(message, playerID);
       chat->setClientID(temp->getID());
       if(!chat->send())
         COUT(3) << "could not send Chat message to client ID: " << temp->getID() << std::endl;
-    }
-    return chat->process();;
-  }
-
-  /**
-  * This function sends out a message to all clients
-  * @param msg message
-  * @return true/false
-  */
-//   bool Server::sendChat(const char *msg) {
-//     char *message = new char [strlen(msg)+10+1];
-//     sprintf(message, "Player %d: %s", CLIENTID_SERVER, msg);
-//     COUT(1) << message << std::endl;
-//     ENetPacket *packet = packet_gen.chatMessage(message);
-//     COUT(5) <<"Server: adding Packets" << std::endl;
-//     return connection->addPacketAll(packet);
-//   }
+      temp = temp->next();
+    }
+    COUT(1) << "Player " << playerID << ": " << message << std::endl;
+    return true;
+  }
+
 
   /**
@@ -174,12 +154,7 @@
     if(timeSinceLastUpdate_>=(1./NETWORK_FREQUENCY)){
       timeSinceLastUpdate_=(float)((int)(timeSinceLastUpdate_*NETWORK_FREQUENCY))/timeSinceLastUpdate_;
-//      timeSinceLastUpdate_-=1./NETWORK_FREQUENCY;
       gamestates_->processGamestates();
       updateGamestate();
     }
-    /*while(timeSinceLastUpdate_>1./NETWORK_FREQUENCY)
-      timeSinceLastUpdate_-=1./NETWORK_FREQUENCY;*/
-//     usleep(5000); // TODO remove
-    return;
   }
 
@@ -230,4 +205,5 @@
     //if(clients->getGamestateID()!=GAMESTATEID_INITIAL)
     sendGameState();
+    sendObjectDeletes();
     COUT(5) << "Server: one sendGameState turn complete, repeat in next tick" << std::endl;
     //std::cout << "sent gamestate" << std::endl;
@@ -276,21 +252,31 @@
       // gs gets automatically deleted by enet callback
     }
-    /*if(added) {
-      //std::cout << "send gamestates from server.cc in sendGameState" << std::endl;
-      return connection->sendPackets();
-    }*/
-    //COUT(5) << "Server: had no gamestates to send" << std::endl;
-    return true;
-  }
-
-//   void Server::processChat( chat *data, int clientId){
-//     char *message = new char [strlen(data->message)+10+1];
-//     sprintf(message, "Player %d: %s", clientId, data->message);
-//     COUT(1) << message << std::endl;
-//     ENetPacket *pck = packet_gen.chatMessage(message);
-//     connection->addPacketAll(pck);
-//     delete[] data->message;
-//     delete data;
-//   }
+    return true;
+  }
+
+  bool Server::sendObjectDeletes(){
+    ClientInformation *temp = ClientInformation::getBegin();
+    packet::DeleteObjects *del = new packet::DeleteObjects();
+    if(!del->fetchIDs())
+      return true;  //everything ok (no deletes this tick)
+//     COUT(3) << "sending DeleteObjects" << std::endl;
+    while(temp != NULL){
+      if( !(temp->getSynched()) ){
+        COUT(5) << "Server: not sending gamestate" << std::endl;
+        temp=temp->next();
+        continue;
+      }
+      int cid = temp->getID(); //get client id
+      packet::DeleteObjects *cd = new packet::DeleteObjects(*del);
+      assert(cd);
+      cd->setClientID(cid);
+      if ( !cd->send() )
+        COUT(3) << "Server: packet with client id (cid): " << cid << " not sended: " << temp->getFailures() << std::endl;
+      temp=temp->next();
+      // gs gets automatically deleted by enet callback
+    }
+    return true;
+  }
+
 
   bool Server::addClient(ENetEvent *event){
@@ -328,10 +314,14 @@
     packet::Welcome *w = new packet::Welcome(temp->getID(), temp->getShipID());
     w->setClientID(temp->getID());
-    assert(w->send());
+    bool b = w->send();
+    assert(b);
     packet::Gamestate *g = new packet::Gamestate();
     g->setClientID(temp->getID());
-    assert(g->collectData(0));
-    assert(g->compressData());
-    assert(g->send());
+    b = g->collectData(0);
+    assert(b);
+    b = g->compressData();
+    assert(b);
+    b = g->send();
+    assert(b);
     return true;
   }
@@ -347,5 +337,5 @@
     orxonox::SpaceShip *no = dynamic_cast<orxonox::SpaceShip *>(id->fabricate());
     no->classID = id->getNetworkID();
-    client->setShipID(no->objectID);
+    client->setShipID(no->getObjectID());
     no->setPosition(orxonox::Vector3(0,0,80));
     no->setScale(10);
@@ -376,5 +366,5 @@
     gamestates_->removeClient(client);
     while(it){
-      if(it->objectID!=client->getShipID()){
+      if(it->getObjectID()!=client->getShipID()){
         ++it;
         continue;
@@ -397,4 +387,18 @@
     gamestates_->removeClient(client);
   }
+  
+  bool Server::chat(std::string message){
+    ClientInformation *temp = ClientInformation::getBegin();
+    packet::Chat *chat;
+    while(temp){
+      chat = new packet::Chat(message, Host::getPlayerID());
+      chat->setClientID(temp->getID());
+      if(!chat->send())
+        COUT(3) << "could not send Chat message to client ID: " << temp->getID() << std::endl;
+      temp = temp->next();
+    }
+    COUT(1) << "Player " << Host::getPlayerID() << ": " << message << std::endl;
+    return true;
+  }
 
 }
Index: code/trunk/src/network/Server.h
===================================================================
--- code/trunk/src/network/Server.h	(revision 1906)
+++ code/trunk/src/network/Server.h	(revision 1907)
@@ -63,9 +63,9 @@
     Server(int port, std::string bindAddress);
     Server(int port, const char *bindAddress);
+    ~Server();
     
     void open();
     void close();
-    bool processChat(packet::Chat *message, unsigned int clientID);
-    bool sendChat(packet::Chat *chat);
+    bool processChat(std::string message, unsigned int playerID);
     bool queuePacket(ENetPacket *packet, int clientID);
     void tick(float time);
@@ -74,6 +74,7 @@
     void updateGamestate();
   private:
+    virtual bool isServer_(){return true;}
     unsigned int shipID(){return 0;}
-    int playerID(){return 0;}
+    unsigned int playerID(){return 0;}
     
     bool addClient(ENetEvent *event);
@@ -85,5 +86,6 @@
     bool processPacket( ENetPacket *packet, ENetPeer *peer );
     bool sendGameState();
-    
+    bool sendObjectDeletes();
+    virtual bool chat(std::string message);
     
     //void processChat( chat *data, int clientId);
